
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ錾
//----------------------------------------------------------------------------------------------

LONG				ReferenceCount;
CRITICAL_SECTION	CriticalSection;

//----------------------------------------------------------------------------------------------
//	IncrementReference
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) IncrementReference()
{
	//	QƃJE^Z
	return( InterlockedIncrement( &ReferenceCount ) );
}

//----------------------------------------------------------------------------------------------
//	DecrementReference
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) DecrementReference()
{
	//	QƃJE^Z
	return( InterlockedDecrement( &ReferenceCount ) );
}

//----------------------------------------------------------------------------------------------
//	EnterCritical
//----------------------------------------------------------------------------------------------
STDAPI_(void) EnterCritical()
{
	//	NeBJ ZNVɓ
	EnterCriticalSection( &CriticalSection );
}

//----------------------------------------------------------------------------------------------
//	LeaveCritical
//----------------------------------------------------------------------------------------------
STDAPI_(void) LeaveCritical()
{
	//	NeBJ ZNVo
	LeaveCriticalSection( &CriticalSection );
}
