
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	PageProc2
//----------------------------------------------------------------------------------------------
INT_PTR CALLBACK PageProc2(
	 HWND	Wnd
	,UINT	Message
	,WPARAM	wParam
	,LPARAM	lParam )
{
	//	ϐ錾
	INT_PTR	Result	= FALSE;

	//	bZ[WɂďU蕪
	switch( Message )
	{
		case WM_INITDIALOG:
			Result	= WM_InitDialog2( Wnd );
			break;

		case WM_COMMAND:
			Result	= WM_Command2( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

		case WM_HSCROLL:
			Result	= WM_HScroll2( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_INITDIALOG
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_InitDialog2( HWND Wnd )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	uXeBbN̋@\v
	InitComboBox( Wnd, IDC_LEFT_STICK_USAGE, CENTER );

	//	uEXeBbN̋@\v
	InitComboBox( Wnd, IDC_RIGHT_STICK_USAGE, CENTER );

	//	uĹ͈v
	InitTrackBar( Wnd, IDC_STICK_DEAD_ZONE, 0, 100, 10, 10 );

	//	uXeBbN̓臒lv
	InitTrackBar( Wnd, IDC_STICK_THRESHOLD, 0, 100, 10, 10 );

	//	IĂݒ_CAOɔf
	SetPageSetting2( Wnd, &CurrentSetting );

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_COMMAND
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Command2(
	 HWND	Wnd
	,WORD	NotifyMessage
	,WORD	ControlID
	,HWND	Control )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_LEFT_STICK_USAGE:
		case IDC_RIGHT_STICK_USAGE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	`FbN{bNX̗LE؂ւ
					SelectComboBox( Control, Wnd, ControlID + 1, CENTER );

					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

		case IDC_LEFT_STICK_REVERSE:
		case IDC_RIGHT_STICK_REVERSE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_HSCROLL
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_HScroll2(
	 HWND	Wnd
	,WORD	Value
	,WORD	Request
	,HWND	Control )
{
	//	ϐ錾
			INT_PTR	Result	= 0;
	static	BOOL	Selecting;

	//	uĹ͈ṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_STICK_DEAD_ZONE ) )
	{
		if( SelectTrackBar( Control, Request, &Selecting ) == TRUE )
		{
			//	vpeB V[gɕύXʒm
			NotifyChange( Wnd );
		}
	}

	//	uXeBbN̓臒lṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_STICK_THRESHOLD ) )
	{
		//	vpeB V[gɕύXʒm
		NotifyChange( Wnd );
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	SetPageSetting2
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetPageSetting2(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;

	//	uXeBbN̋@\v
	for( Index = 0; Index < 2; Index ++ )
	{
		SetComboBox(
			 Wnd
			,IDC_LEFT_STICK_USAGE + ( Index * 2 )
			,Setting->StickUsage[Index]
			,IDC_LEFT_STICK_REVERSE + ( Index * 2 )
			,CENTER );
		SetCheckBox(
			 Wnd
			,IDC_LEFT_STICK_REVERSE + ( Index * 2 )
			,Setting->StickReverse[Index] );
	}

	//	uڍאݒv
	SetTrackBarRange(
		 Wnd
		,IDC_STICK_DEAD_ZONE
		,Setting->StickMinThreshold
		,Setting->StickMaxThreshold );
	SetTrackBarPos( Wnd, IDC_STICK_DEAD_ZONE, Setting->StickMinThreshold );
	SetTrackBarPos( Wnd, IDC_STICK_THRESHOLD, Setting->StickHatSwitchThreshold );
}

//----------------------------------------------------------------------------------------------
//	GetPageSetting2
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetPageSetting2(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;

	//	uXeBbN̋@\v
	for( Index = 0; Index < 2; Index ++ )
	{
		Setting->StickUsage[Index]		= GetComboBox(
											 Wnd
											,IDC_LEFT_STICK_USAGE + ( Index * 2 ) );
		Setting->StickReverse[Index]	= GetCheckBox(
											 Wnd
											,IDC_LEFT_STICK_REVERSE + ( Index * 2 ) );
	}

	//	uڍאݒv
	GetTrackBarRange(
		 Wnd
		,IDC_STICK_DEAD_ZONE
		,&Setting->StickMinThreshold
		,&Setting->StickMaxThreshold );
	Setting->StickHatSwitchThreshold	= GetTrackBarPos( Wnd, IDC_STICK_THRESHOLD );
}
