
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	PageProc5
//----------------------------------------------------------------------------------------------
INT_PTR CALLBACK PageProc5(
	 HWND	Wnd
	,UINT	Message
	,WPARAM	wParam
	,LPARAM	lParam )
{
	//	ϐ錾
	INT_PTR	Result	= FALSE;

	//	bZ[WɂďU蕪
	switch( Message )
	{
		case WM_INITDIALOG:
			Result	= WM_InitDialog5( Wnd );
			break;

		case WM_COMMAND:
			Result	= WM_Command5( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

		case WM_HSCROLL:
			Result	= WM_HScroll5( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_INITDIALOG
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_InitDialog5( HWND Wnd )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	u{^̈ꗗv
	InitListBox( Wnd, IDC_BUTTON_LIST, BUTTON_LIST );

	//	u{^̋@\v
	InitComboBox( Wnd, IDC_BUTTON_USAGE, STRAIGHT );

	//	u{^̘Aˑxv
	InitTrackBar( Wnd, IDC_BUTTON_RAPID_FIRE_SPEED, 0, 100, 20, 10 );

	//	uڍאݒv
	InitComboBox( Wnd, IDC_RING_LIGHT, RING_LIGHT );

	//	IĂݒ_CAOɔf
	SetPageSetting5( Wnd, &CurrentSetting );

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_COMMAND
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Command5(
	 HWND	Wnd
	,WORD	NotifyMessage
	,WORD	ControlID
	,HWND	Control )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_BUTTON_LIST:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case LBN_SELCHANGE:
					//	{^̋@\擾
					ChangeButtonFunction( Wnd, FALSE );
					break;
			}
			break;

		case IDC_BUTTON_USAGE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	{^̋@\ݒ肷
					ChangeButtonFunction( Wnd, TRUE );

					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

		case IDC_BUTTON_RAPID_FIRE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	{^̋@\ݒ肷
					ChangeButtonFunction( Wnd, TRUE );

					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

		case IDC_RING_LIGHT:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_HSCROLL
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_HScroll5(
	 HWND	Wnd
	,WORD	Request
	,WORD	Value
	,HWND	Control )
{
	//	ϐ錾
			INT_PTR	Result	= 0;
	static	BOOL	Selecting;

	//	u{^̘AˑxṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_BUTTON_RAPID_FIRE_SPEED ) )
	{
		//	{^̋@\ݒ肷
		ChangeButtonFunction( Wnd, TRUE );

		//	vpeB V[gɕύXʒm
		NotifyChange( Wnd );
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	ChangeButtonFunction
//----------------------------------------------------------------------------------------------
STDAPI_(void) ChangeButtonFunction(
	 HWND	Wnd
	,BOOL	Update )
{
	//	ϐ錾
	HWND	Control;
	ULONG	Button;
	ULONG	ItemData;
	ULONG	Usage;
	ULONG	RapidFire;
	ULONG	RapidFireSpeed;

	if( Update == FALSE )
	{
		//	{^擾
		Control			= GetDlgItem( Wnd, IDC_BUTTON_LIST );
		Button			= (ULONG)SendMessage( Control, LB_GETCURSEL, 0, 0 );
		ItemData		= (ULONG)SendMessage( Control, LB_GETITEMDATA, Button, 0 );
		Usage			= LOWORD( ItemData );
		RapidFire		= LOBYTE( HIWORD( ItemData ) );
		RapidFireSpeed	= HIBYTE( HIWORD( ItemData ) );
		//	{^̋@\ݒ肷
		Control			= GetDlgItem( Wnd, IDC_BUTTON_USAGE );
		SendMessage( Control, CB_SETCURSEL, Usage, 0 );
		//	{^̘A˂ݒ肷
		Control			= GetDlgItem( Wnd, IDC_BUTTON_RAPID_FIRE );
		SendMessage( Control, BM_SETCHECK, RapidFire, 0 );
		//	{^̘Aˑxݒ肷
		Control			= GetDlgItem( Wnd, IDC_BUTTON_RAPID_FIRE_SPEED );
		SendMessage( Control, TBM_SETPOS, TRUE, RapidFireSpeed );
	} else {
		//	{^̋@\擾
		Control			= GetDlgItem( Wnd, IDC_BUTTON_USAGE );
		Usage			= (ULONG)SendMessage( Control, CB_GETCURSEL, 0, 0 );
		//	{^̘A˂擾
		Control			= GetDlgItem( Wnd, IDC_BUTTON_RAPID_FIRE );
		RapidFire		= (ULONG)SendMessage( Control, BM_GETCHECK, 0, 0 );
		//	{^̘Aˑx擾
		Control			= GetDlgItem( Wnd, IDC_BUTTON_RAPID_FIRE_SPEED );
		RapidFireSpeed	= (ULONG)SendMessage( Control, TBM_GETPOS, 0, 0 );
		//	{^ɐݒ肷
		Control			= GetDlgItem( Wnd, IDC_BUTTON_LIST );
		Button			= (ULONG)SendMessage( Control, LB_GETCURSEL, 0, 0 );
		SendMessage(
			 Control
			,LB_SETITEMDATA
			,Button
			,MAKELONG( (WORD)Usage, MAKEWORD( (BYTE)RapidFire, (BYTE)RapidFireSpeed ) ) );
	}

	//	`FbN {bNXAgbN o[̗LE؂ւ
	if( Usage >= NOTHING_POS_STRAIGHT )
	{
		EnableControl( Wnd, IDC_BUTTON_RAPID_FIRE, IDC_STATIC_503, FALSE );
	} else {
		EnableControl( Wnd, IDC_BUTTON_RAPID_FIRE, IDC_BUTTON_RAPID_FIRE, TRUE );
		if( RapidFire == 0 )
		{
			EnableControl( Wnd, IDC_STATIC_501, IDC_STATIC_503, FALSE );
		} else {
			EnableControl( Wnd, IDC_STATIC_501, IDC_STATIC_503, TRUE );
		}
	}
}

//----------------------------------------------------------------------------------------------
//	SetPageSetting5
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetPageSetting5(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;

	//	u{^̋@\v
	for( Index = 0; Index < 11; Index ++ )
	{
		SetListBoxItemData(
			 Wnd
			,IDC_BUTTON_LIST
			,Index
			,Setting->ButtonUsage[Index]
			,Setting->ButtonRapidFire[Index]
			,Setting->ButtonRapidFireSpeed[Index] );
	}
	SetListBox( Wnd, IDC_BUTTON_LIST, 0 );
	SetComboBox(
		 Wnd
		,IDC_BUTTON_USAGE
		,Setting->ButtonUsage[0]
		,IDC_BUTTON_RAPID_FIRE
		,STRAIGHT );
	SetCheckBox( Wnd, IDC_BUTTON_RAPID_FIRE, Setting->ButtonRapidFire[0] );
	SetTrackBarPos( Wnd, IDC_BUTTON_RAPID_FIRE_SPEED, Setting->ButtonRapidFireSpeed[0] );
	if( Setting->ButtonUsage[0] >= NOTHING_POS_STRAIGHT )
	{
		EnableControl( Wnd, IDC_BUTTON_RAPID_FIRE, IDC_STATIC_503, FALSE );
	} else {
		EnableControl( Wnd, IDC_BUTTON_RAPID_FIRE, IDC_BUTTON_RAPID_FIRE, TRUE );
		if( Setting->ButtonRapidFire[0] == 0 )
		{
			EnableControl( Wnd, IDC_STATIC_501, IDC_STATIC_503, FALSE );
		} else {
			EnableControl( Wnd, IDC_STATIC_501, IDC_STATIC_503, TRUE );
		}
	}

	//	uڍאݒv
	SendMessage(
		 GetDlgItem( Wnd, IDC_RING_LIGHT )
		,CB_SETCURSEL
		,Setting->RingLightPattern
		,0 );

}

//----------------------------------------------------------------------------------------------
//	GetPageSetting5
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetPageSetting5(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;

	//	u{^̋@\v
	for( Index = 0; Index < 11; Index ++ )
	{
		GetListBoxItemData(
			 Wnd
			,IDC_BUTTON_LIST
			,Index
			,&Setting->ButtonUsage[Index]
			,&Setting->ButtonRapidFire[Index]
			,&Setting->ButtonRapidFireSpeed[Index] );
	}

	//	uڍאݒv
	Setting->RingLightPattern	= GetComboBox( Wnd, IDC_RING_LIGHT );

}
