
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	PageProc7
//----------------------------------------------------------------------------------------------
INT_PTR CALLBACK PageProc7(
	 HWND	Wnd
	,UINT	Message
	,WPARAM	wParam
	,LPARAM	lParam )
{
	//	ϐ錾
	INT_PTR	Result	= FALSE;

	//	bZ[WɂďU蕪
	switch( Message )
	{
		case WM_INITDIALOG:
			Result	= WM_InitDialog7( Wnd );
			break;

		case WM_COMMAND:
			Result	= WM_Command7( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_INITDIALOG
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_InitDialog7( HWND Wnd )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	u@\̈ꗗv
	InitListBox( Wnd, IDC_SLIDER_LIST, SLIDER_LIST );

	//	u݊[hv
	InitComboBox( Wnd, IDC_LIMITATION_MODE, LIMITATION_MODE );

	//	IĂݒ_CAOɔf
	SetPageSetting7( Wnd, &CurrentSetting );

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_COMMAND
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Command7(
	 HWND	Wnd
	,WORD	NotifyMessage
	,WORD	ControlID
	,HWND	Control )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_SLIDER_LIST:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case LBN_SELCHANGE:
					//	XC_[̋@\擾
					ChangeSliderFunction( Wnd, FALSE );
					break;
			}
			break;

		case IDC_SLIDE_SLIDER_VALUE:
		case IDC_SLIDE_CENTER_VALUE:
		case IDC_REVERSE_SLIDER_VALUE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	XC_[̋@\ݒ肷
					ChangeSliderFunction( Wnd, TRUE );

					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

		case IDC_STICK_DEAD_ZONE_BOX:
		case IDC_STICK_DEAD_ZONE_CIRCLE:
		case IDC_DEVICES_ARE_POLLED:
		case IDC_REDUCE_OUTPUT_REPORT:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

		case IDC_LIMITATION_MODE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	ChangeSliderFunction
//----------------------------------------------------------------------------------------------
STDAPI_(void) ChangeSliderFunction(
	 HWND	Wnd
	,BOOL	Update )
{
	//	ϐ錾
	HWND	Control;
	ULONG	Slider;
	ULONG	ItemData;
	ULONG	SlideValue;
	ULONG	CenterValue;
	ULONG	ReverseValue;

	if( Update == FALSE )
	{
		//	XC_[擾
		Control			= GetDlgItem( Wnd, IDC_SLIDER_LIST );
		Slider			= (ULONG)SendMessage( Control, LB_GETCURSEL, 0, 0 );
		ItemData		= (ULONG)SendMessage( Control, LB_GETITEMDATA, Slider, 0 );
		SlideValue		= LOWORD( ItemData );
		CenterValue		= LOBYTE( HIWORD( ItemData ) );
		ReverseValue	= HIBYTE( HIWORD( ItemData ) );
		//	l̒Slɂݒ肷
		Control			= GetDlgItem( Wnd, IDC_SLIDE_SLIDER_VALUE );
		SendMessage( Control, BM_SETCHECK, SlideValue, 0 );
		//	Sl炷ݒ肷
		Control			= GetDlgItem( Wnd, IDC_SLIDE_CENTER_VALUE );
		SendMessage( Control, BM_SETCHECK, CenterValue, 0 );
		//	͂l𔽓]ݒ肷
		Control			= GetDlgItem( Wnd, IDC_REVERSE_SLIDER_VALUE );
		SendMessage( Control, BM_SETCHECK, ReverseValue, 0 );
	} else {
		//	l̒Slɂ擾
		Control			= GetDlgItem( Wnd, IDC_SLIDE_SLIDER_VALUE );
		SlideValue		= (ULONG)SendMessage( Control, BM_GETCHECK, 0, 0 );
		//	Sl炷擾
		Control			= GetDlgItem( Wnd, IDC_SLIDE_CENTER_VALUE );
		CenterValue		= (ULONG)SendMessage( Control, BM_GETCHECK, 0, 0 );
		//	͂l𔽓]擾
		Control			= GetDlgItem( Wnd, IDC_REVERSE_SLIDER_VALUE );
		ReverseValue	= (ULONG)SendMessage( Control, BM_GETCHECK, 0, 0 );
		//	XC_[ɐݒ肷
		Control			= GetDlgItem( Wnd, IDC_SLIDER_LIST );
		Slider			= (ULONG)SendMessage( Control, LB_GETCURSEL, 0, 0 );
		SendMessage(
			 Control
			,LB_SETITEMDATA
			,Slider
			,MAKELONG( (WORD)SlideValue, MAKEWORD( (BYTE)CenterValue, (BYTE)ReverseValue ) ) );
	}

	//	`FbN {bNX̗LE؂ւ
	if( SlideValue == 0 )
	{
		EnableControl( Wnd, IDC_SLIDE_CENTER_VALUE, IDC_SLIDE_CENTER_VALUE, FALSE );
	} else {
		EnableControl( Wnd, IDC_SLIDE_CENTER_VALUE, IDC_SLIDE_CENTER_VALUE, TRUE );
	}
}

//----------------------------------------------------------------------------------------------
//	SetPageSetting7
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetPageSetting7(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;

	//	uXeBbN̗Ĺ͈v
	if( Setting->StickDeadZoneType == 0 )
	{
		SetCheckBox( Wnd, IDC_STICK_DEAD_ZONE_BOX, BST_CHECKED );
		SetCheckBox( Wnd, IDC_STICK_DEAD_ZONE_CIRCLE, BST_UNCHECKED );
	} else {
		SetCheckBox( Wnd, IDC_STICK_DEAD_ZONE_BOX, BST_UNCHECKED );
		SetCheckBox( Wnd, IDC_STICK_DEAD_ZONE_CIRCLE, BST_CHECKED );
	}

	//	uZ AZ ]AXC_[v
	for( Index = 0; Index < 4; Index ++ )
	{
		SetListBoxItemData(
			 Wnd
			,IDC_SLIDER_LIST
			,Index
			,Setting->SlideSliderValue[Index]
			,Setting->SlideCenterValue[Index]
			,Setting->ReverseSliderValue[Index] );
	}
	SetListBox( Wnd, IDC_SLIDER_LIST, 0 );
	SetCheckBox( Wnd, IDC_SLIDE_SLIDER_VALUE, Setting->SlideSliderValue[0] );
	SetCheckBox( Wnd, IDC_SLIDE_CENTER_VALUE, Setting->SlideCenterValue[0] );
	if( Setting->SlideSliderValue[0] == 0 )
	{
		EnableControl( Wnd, IDC_SLIDE_CENTER_VALUE, IDC_SLIDE_CENTER_VALUE, FALSE );
	} else {
		EnableControl( Wnd, IDC_SLIDE_CENTER_VALUE, IDC_SLIDE_CENTER_VALUE, TRUE );
	}
	SetCheckBox( Wnd, IDC_REVERSE_SLIDER_VALUE, Setting->ReverseSliderValue[0] );

	//	u݊v
	SendMessage(
		 GetDlgItem( Wnd, IDC_LIMITATION_MODE )
		,CB_SETCURSEL
		,Setting->LimitationMode
		,0 );
	SetCheckBox( Wnd, IDC_DEVICES_ARE_POLLED, Setting->DevicesArePolled );
	SetCheckBox( Wnd, IDC_REDUCE_OUTPUT_REPORT, Setting->ReduceOutputReport );
}

//----------------------------------------------------------------------------------------------
//	GetPageSetting7
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetPageSetting7(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;
	ULONG	Dummy;

	//	uXeBbN̗Ĺ͈v
	if( GetCheckBox( Wnd, IDC_STICK_DEAD_ZONE_BOX ) == BST_CHECKED )
	{
		Setting->StickDeadZoneType	= 0;
	} else {
		Setting->StickDeadZoneType	= 1;
	}

	//	uZ AZ ]AXC_[v
	for( Index = 0; Index < 4; Index ++ )
	{
		GetListBoxItemData(
			 Wnd
			,IDC_SLIDER_LIST
			,Index
			,&Setting->SlideSliderValue[Index]
			,&Setting->SlideCenterValue[Index]
			,&Setting->ReverseSliderValue[Index] );
	}

	//	u݊v
	Setting->LimitationMode		= GetComboBox( Wnd, IDC_LIMITATION_MODE );
	Setting->DevicesArePolled	= GetCheckBox( Wnd, IDC_DEVICES_ARE_POLLED );
	Setting->ReduceOutputReport	= GetCheckBox( Wnd, IDC_REDUCE_OUTPUT_REPORT );
}
