
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	NotifyChange
//----------------------------------------------------------------------------------------------
STDAPI_(void) NotifyChange( HWND Wnd )
{
	//	ϐ錾
	HWND	Dialog	= GetParent( Wnd );
	HWND	Page	= PropSheet_IndexToHwnd( Dialog, CONTROLLER );

	if( ModifiedFlag == FALSE )
	{
		//	ݒ胊Xg̓eXVAύXς݂̐ݒI
		ModifiedFlag	= TRUE;
		InitSettingList( Page, IDC_SETTING_LIST );
		SendMessage(
			 GetDlgItem( Page, IDC_SETTING_LIST )
			,CB_SETCURSEL
			,0
			,0 );

		//	u폜v𖳌ɂ
		EnableWindow( GetDlgItem( Page, IDC_SETTING_DELETE ), FALSE );
	}

	//	vpeB V[gɕύXʒm
	PropSheet_Changed( Dialog, Page );
}

//----------------------------------------------------------------------------------------------
//	SetDialogSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetDialogSetting(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	HWND	Dialog	= GetParent( Wnd );
	HWND	Page;

	//	XeBbN
	Page	= PropSheet_IndexToHwnd( Dialog, STICK );
	if( Page != NULL )
	{
		SetPageSetting2( Page, Setting );
	}

	//	pbh
	Page	= PropSheet_IndexToHwnd( Dialog, DIRECTIONAL_PAD );
	if( Page != NULL )
	{
		SetPageSetting3( Page, Setting );
	}

	//	gK[
	Page	= PropSheet_IndexToHwnd( Dialog, TRIGGER );
	if( Page != NULL )
	{
		SetPageSetting4( Page, Setting );
	}

	//	{^
	Page	= PropSheet_IndexToHwnd( Dialog, BUTTON );
	if( Page != NULL )
	{
		SetPageSetting5( Page, Setting );
	}

	//	U
	Page	= PropSheet_IndexToHwnd( Dialog, FORCE_FEEDBACK );
	if( Page != NULL )
	{
		SetPageSetting6( Page, Setting );
	}

	//	ڍאݒ
	Page	= PropSheet_IndexToHwnd( Dialog, DETAIL );
	if( Page != NULL )
	{
		SetPageSetting7( Page, Setting );
	}
}

//----------------------------------------------------------------------------------------------
//	GetDialogSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetDialogSetting(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	HWND	Dialog	= GetParent( Wnd );
	HWND	Page;

	//	XeBbN
	Page	= PropSheet_IndexToHwnd( Dialog, STICK );
	if( Page != NULL )
	{
		GetPageSetting2( Page, Setting );
	}

	//	pbh
	Page	= PropSheet_IndexToHwnd( Dialog, DIRECTIONAL_PAD );
	if( Page != NULL )
	{
		GetPageSetting3( Page, Setting );
	}

	//	gK[
	Page	= PropSheet_IndexToHwnd( Dialog, TRIGGER );
	if( Page != NULL )
	{
		GetPageSetting4( Page, Setting );
	}

	//	{^
	Page	= PropSheet_IndexToHwnd( Dialog, BUTTON );
	if( Page != NULL )
	{
		GetPageSetting5( Page, Setting );
	}

	//	U
	Page	= PropSheet_IndexToHwnd( Dialog, FORCE_FEEDBACK );
	if( Page != NULL )
	{
		GetPageSetting6( Page, Setting );
	}

	//	ڍאݒ
	Page	= PropSheet_IndexToHwnd( Dialog, DETAIL );
	if( Page != NULL )
	{
		GetPageSetting7( Page, Setting );
	}
}

//----------------------------------------------------------------------------------------------
//	InitComboBox
//----------------------------------------------------------------------------------------------
STDAPI_(void) InitComboBox(
	 HWND	Wnd
	,ULONG	ComboBoxID
	,LONG	ComboBoxType )
{
	//	ϐ錾
	HWND	ComboBox	= GetDlgItem( Wnd, ComboBoxID );
	_TCHAR	FunctionName[MAX_PATH];
	LONG	StartID;
	LONG	EndID;
	LONG	ResourceID;

	//	R{ {bNX̎ނɂďU蕪
	switch( ComboBoxType )
	{
		case CENTER:
			StartID	= IDS_AXIS;
			EndID	= IDS_HAT_SWITCH4;
			break;

		case CENTER_PLUS:
			StartID	= IDS_AXIS;
			EndID	= IDS_BUTTON_OR_SLIDER;
			break;

		case STRAIGHT:
			StartID	= IDS_Z_AXIS_PLUS;
			EndID	= IDS_BUTTON32;
			break;

		case RING_LIGHT:
			StartID	= IDS_RING_LIGHT_0;
			EndID	= IDS_RING_LIGHT_15;
			break;

		case LIMITATION_MODE:
			StartID	= IDS_LIMITATION_MODE_0;
			EndID	= IDS_LIMITATION_MODE_3;
			break;
	}

	//	\[X@\̂擾AR{ {bNXɑ}
	for( ResourceID = StartID; ResourceID <= EndID; ResourceID ++ )
	{
		LoadString( Instance, ResourceID, FunctionName, sizeof( FunctionName ) );
		SendMessage( ComboBox, CB_INSERTSTRING, ResourceID - StartID, (LPARAM)FunctionName );
	}
	//	uȂvR{ {bNXɑ}
	if(	( ComboBoxType != RING_LIGHT )
	&&	( ComboBoxType != LIMITATION_MODE ) )
	{
		LoadString( Instance, IDS_NOTHING, FunctionName, sizeof( FunctionName ) );
		SendMessage( ComboBox, CB_INSERTSTRING, ResourceID - StartID, (LPARAM)FunctionName );
	}
}

//----------------------------------------------------------------------------------------------
//	SelectComboBox
//----------------------------------------------------------------------------------------------
STDAPI_(void) SelectComboBox(
	 HWND	ComboBox
	,HWND	Wnd
	,ULONG	CheckBoxID
	,LONG	ComboBoxType )
{
	//	ϐ錾
	LONG	NothingPosition;

	//	R{ {bNX̎ނɂďU蕪
	switch( ComboBoxType )
	{
		case CENTER:
			NothingPosition	= NOTHING_POS_CENTER;
			break;

		case CENTER_PLUS:
			NothingPosition	= NOTHING_POS_CENTER_PLUS;
			break;

		case STRAIGHT:
			NothingPosition	= NOTHING_POS_STRAIGHT;
			break;
	}

	//	R{ {bNXőIĂ鏇Ԃwl傫΁A`FbN {bNX𖳌ɂ
	if( SendMessage( ComboBox, CB_GETCURSEL, 0, 0 ) >= NothingPosition )
	{
		EnableWindow( GetDlgItem( Wnd, CheckBoxID ), FALSE );
	} else {
		EnableWindow( GetDlgItem( Wnd, CheckBoxID ), TRUE );
	}
}

//----------------------------------------------------------------------------------------------
//	SetComboBox
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetComboBox(
	 HWND	Wnd
	,ULONG	ComboBoxID
	,LONG	ComboBoxIndex
	,ULONG	CheckBoxID
	,LONG	ComboBoxType )
{
	//	ϐ錾
	LONG	NothingPosition;

	//	R{ {bNX̎ނɂďU蕪
	switch( ComboBoxType )
	{
		case CENTER:
			NothingPosition	= NOTHING_POS_CENTER;
			break;

		case CENTER_PLUS:
			NothingPosition	= NOTHING_POS_CENTER_PLUS;
			break;

		case STRAIGHT:
			NothingPosition	= NOTHING_POS_STRAIGHT;
			break;
	}

	//	R{{bNX̏Ԃݒ肷
	SendMessage( GetDlgItem( Wnd, ComboBoxID ), CB_SETCURSEL, ComboBoxIndex, 0 );

	//	R{ {bNX̏Ԃwl傫΁A`FbN {bNX𖳌ɂ
	if( ComboBoxIndex >= NothingPosition )
	{
		EnableWindow( GetDlgItem( Wnd, CheckBoxID ), FALSE );
	} else {
		EnableWindow( GetDlgItem( Wnd, CheckBoxID ), TRUE );
	}
}

//----------------------------------------------------------------------------------------------
//	GetComboBox
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) GetComboBox(
	 HWND	Wnd
	,ULONG	ComboBoxID )
{
	//	R{ {bNXőIĂ鏇ԂԂ
	return( (LONG)SendMessage( GetDlgItem( Wnd, ComboBoxID ), CB_GETCURSEL, 0, 0 ) );
}

//----------------------------------------------------------------------------------------------
//	InitTrackBar
//----------------------------------------------------------------------------------------------
STDAPI_(void) InitTrackBar(
	 HWND	Wnd
	,ULONG	TrackBarID
	,LONG	Min
	,LONG	Max
	,LONG	TicFreq
	,LONG	PageSize )
{
	//	ϐ錾
	HWND	TrackBar	= GetDlgItem( Wnd, TrackBarID );

	//	gbN o[
	SendMessage( TrackBar, TBM_SETRANGE, FALSE, MAKELONG( Min, Max ) );
	SendMessage( TrackBar, TBM_SETTICFREQ, TicFreq, 0 );
	SendMessage( TrackBar, TBM_SETPAGESIZE, 0, PageSize );
}

//----------------------------------------------------------------------------------------------
//	SelectTrackBar
//----------------------------------------------------------------------------------------------
STDAPI_(BOOL) SelectTrackBar(
	 HWND	TrackBar
	,WORD	Request
	,BOOL *	Selecting )
{
	//	ϐ錾
	BOOL	Result	= FALSE;
	LONG	CurPos;

	//	gbN o[݈̌ʒu擾
	CurPos	= (LONG)SendMessage( TrackBar, TBM_GETPOS, 0, 0 );

	//	NGXgɂďU蕪
	switch( Request )
	{
		case TB_ENDTRACK:
			if( *Selecting == TRUE )
			{
				//	͈͂̑II
				SendMessage( TrackBar, TBM_SETSELEND, TRUE, (LPARAM)CurPos );
				*Selecting	= FALSE;
			}
			break;

		default:
			if( GetAsyncKeyState(VK_SHIFT) & 0x80000000 )
			{
				if( *Selecting == FALSE )
				{
					//	͈͂̑IJn
					SendMessage( TrackBar, TBM_CLEARSEL, TRUE, 0 );
					SendMessage( TrackBar, TBM_SETSELSTART, TRUE, (LPARAM)CurPos );
					*Selecting	= TRUE;
					//	vpeB V[gɕύXʒm
					Result	= TRUE;
				} else {
					//	͈͂I
					SendMessage( TrackBar, TBM_SETSELEND, TRUE, (LPARAM)CurPos );
				}
			} else {
				if( *Selecting == TRUE )
				{
					//	͈͂I𒆂 Shift L[𗣂
					SendMessage( TrackBar, TBM_SETSELEND, TRUE, (LPARAM)CurPos );
					*Selecting	= FALSE;
				}
			}
			break;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	SetTrackBarPos
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetTrackBarPos(
	 HWND	Wnd
	,ULONG	TrackBarID
	,LONG	Pos )
{
	//	gbN o[̈ʒuݒ肷
	SendMessage( GetDlgItem( Wnd, TrackBarID ), TBM_SETPOS, TRUE, Pos );
}

//----------------------------------------------------------------------------------------------
//	GetTrackBarPos
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) GetTrackBarPos(
	 HWND	Wnd
	,ULONG	TrackBarID )
{
	//	gbN o[̈ʒuԂ
	return( (LONG)SendMessage( GetDlgItem( Wnd, TrackBarID ), TBM_GETPOS, 0, 0 ) );
}

//----------------------------------------------------------------------------------------------
//	SetTrackBarRange
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetTrackBarRange(
	 HWND	Wnd
	,ULONG	TrackBarID
	,LONG	Start
	,LONG	End )
{
	//	ϐ錾
	HWND	TrackBar	= GetDlgItem( Wnd, TrackBarID );

	//	gbN o[͈̔͂ݒ肷
	SendMessage( TrackBar, TBM_SETSELSTART, TRUE, Start );
	SendMessage( TrackBar, TBM_SETSELEND, TRUE, End );
}

//----------------------------------------------------------------------------------------------
//	GetTrackBarRange
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetTrackBarRange(
	 HWND	Wnd
	,ULONG	TrackBarID
	,LONG *	Start
	,LONG *	End )
{
	//	ϐ錾
	HWND	TrackBar	= GetDlgItem( Wnd, TrackBarID );

	//	gbN o[͈̔͂Ԃ
	*Start	= (LONG)SendMessage( TrackBar, TBM_GETSELSTART, 0, 0 );
	*End	= (LONG)SendMessage( TrackBar, TBM_GETSELEND, 0, 0 );
}

//----------------------------------------------------------------------------------------------
//	SetCheckBox
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetCheckBox(
	 HWND	Wnd
	,ULONG	CheckBoxID
	,LONG	State )
{
	//	`FbN {bNX̏Ԃݒ肷
	SendMessage( GetDlgItem( Wnd, CheckBoxID ), BM_SETCHECK, State, 0 );
}

//----------------------------------------------------------------------------------------------
//	GetCheckBox
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) GetCheckBox(
	 HWND	Wnd
	,ULONG	CheckBoxID )
{
	//	`FbN {bNX̏ԂԂ
	return( (LONG)SendMessage( GetDlgItem( Wnd, CheckBoxID ), BM_GETCHECK, 0, 0 ) );
}

//----------------------------------------------------------------------------------------------
//	InitListBox
//----------------------------------------------------------------------------------------------
STDAPI_(void) InitListBox(
	 HWND	Wnd
	,ULONG	ListBoxID
	,LONG	ListBoxType )
{
	//	ϐ錾
	HWND	ListBox	= GetDlgItem( Wnd, ListBoxID );
	_TCHAR	ListBoxText[MAX_PATH];
	LONG	StartID;
	LONG	EndID;
	LONG	ResourceID;

	//	Xg {bNX̎ނɂďU蕪
	switch( ListBoxType )
	{
		case BUTTON_LIST:
			StartID	= IDS_A_BUTTON;
			EndID	= IDS_XBOX_GUIDE_BUTTON;
			break;

		case SLIDER_LIST:
			StartID	= IDS_Z_AXIS;
			EndID	= IDS_SLIDER2;
			break;
	}

	//	\[X{^̂擾AXg {bNXɑ}
	for( ResourceID = StartID; ResourceID <= EndID; ResourceID ++ )
	{
		LoadString( Instance, ResourceID, ListBoxText, sizeof( ListBoxText ) );
		SendMessage( ListBox, LB_ADDSTRING, ResourceID - StartID, (LPARAM)ListBoxText );
	}
}

//----------------------------------------------------------------------------------------------
//	SetListBox
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetListBox(
	 HWND	Wnd
	,ULONG	ListBoxID
	,LONG	Index )
{
	//	Xg {bNX̃ACe f[^ݒ肷
	SendMessage( GetDlgItem( Wnd, ListBoxID ), LB_SETCURSEL, Index, 0 );
}

//----------------------------------------------------------------------------------------------
//	SetListBoxItemData
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetListBoxItemData(
	 HWND	Wnd
	,ULONG	ListBoxID
	,LONG	Index
	,LONG	Usage
	,LONG	RapidFire
	,LONG	RapidFireSpeed )
{
	//	Xg {bNX̃ACe f[^ݒ肷
	SendMessage(
		 GetDlgItem( Wnd, ListBoxID )
		,LB_SETITEMDATA
		,Index
		,MAKELONG( Usage, MAKEWORD( RapidFire, RapidFireSpeed ) ) );
}

//----------------------------------------------------------------------------------------------
//	GetListBoxItemData
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetListBoxItemData(
	 HWND		Wnd
	,ULONG		ListBoxID
	,LONG		Index
	,ULONG *	Usage
	,ULONG *	RapidFire
	,ULONG *	RapidFireSpeed )
{
	//	ϐ錾
	ULONG	ItemData;

	//	Xg {bNX̃ACe f[^Ԃ
	ItemData		= (ULONG)SendMessage(
						 GetDlgItem( Wnd, ListBoxID )
						,LB_GETITEMDATA
						,Index
						,0 );
	*Usage			= LOWORD( ItemData );
	*RapidFire		= LOBYTE( HIWORD( ItemData ) );
	*RapidFireSpeed	= HIBYTE( HIWORD( ItemData ) );
}

//----------------------------------------------------------------------------------------------
//	UpdateWindowText
//----------------------------------------------------------------------------------------------
STDAPI_(void) UpdateWindowText(
	 HWND	Wnd
	,ULONG	TextID
	,LONG	Value )
{
	//	ϐ錾
	HWND	Text	= GetDlgItem( Wnd, TextID );
	_TCHAR	OldText[MAX_PATH];
	_TCHAR	NewText[MAX_PATH];

	//	EBhE̕𐶐
	_stprintf( NewText, _T("%d"), Value );

	//	EBhE̕񂪈قȂΒu
	GetWindowText( Text, OldText, sizeof( OldText ) );
	if( _tcscmp( OldText, NewText ) != 0 )
	{
		SetWindowText( Text, NewText );
	}
}

//----------------------------------------------------------------------------------------------
//	UpdateWindowTextPlus
//----------------------------------------------------------------------------------------------
STDAPI_(void) UpdateWindowTextPlus(
	 HWND	Wnd
	,ULONG	TextID
	,ULONG	Value )
{
	//	ϐ錾
	HWND	Text	= GetDlgItem( Wnd, TextID );
	_TCHAR	NewText[MAX_PATH];
	_TCHAR	DstText[MAX_PATH];
	LONG	Index;

	//	EBhE̕𐶐
	ZeroMemory( NewText, sizeof( NewText ) );
	for( Index = 0; Index < 32; Index ++ )
	{
		if( Value & ( 1 << Index ) )
		{
			_stprintf( DstText, _T(" %02d"), Index + 1 );
			_tcscat( NewText, DstText );
		}
	}

	//	EBhE̕񂪈قȂΒu
	GetWindowText( Text, DstText, sizeof( DstText ) );
	if( _tcscmp( DstText, NewText ) != 0 )
	{
		SetWindowText( Text, NewText );
	}
}

//----------------------------------------------------------------------------------------------
//	ShowMessageBox
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) ShowMessageBox(
	 HWND	Wnd
	,ULONG	TitleID
	,ULONG	MessageID
	,ULONG	Type )
{
	//	ϐ錾
	_TCHAR	Title[MAX_PATH];
	_TCHAR	Message[MAX_PATH];

	//	bZ[W {bNX\
	LoadString( Instance, TitleID, Title, sizeof( Title ) );
	LoadString( Instance, MessageID, Message, sizeof( Message ) );
	return( MessageBox( Wnd, Message, Title, Type ) );
}

//----------------------------------------------------------------------------------------------
//	ShowMessageBoxPlus
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) ShowMessageBoxPlus(
	 HWND		Wnd
	,ULONG		TitleID
	,ULONG		MessageID
	,_TCHAR *	Message
	,ULONG		Type )
{
	//	ϐ錾
	_TCHAR	Title[MAX_PATH];
	_TCHAR	MessageRes[MAX_PATH];
	_TCHAR	MessagePlus[MAX_PATH];

	//	bZ[W {bNX\
	LoadString( Instance, TitleID, Title, sizeof( Title ) );
	LoadString( Instance, MessageID, MessageRes, sizeof( MessageRes ) );
	_stprintf( MessagePlus, MessageRes, Message );
	return( MessageBox( Wnd, MessagePlus, Title, Type ) );
}

//----------------------------------------------------------------------------------------------
//	EnableControl
//----------------------------------------------------------------------------------------------
STDAPI_(void) EnableControl(
	 HWND	Wnd
	,ULONG	Start
	,ULONG	End
	,BOOL	State )
{
	//	ϐ錾
	ULONG	i;

	//	Rg[̗LE؂ւ
	for( i = Start; i <= End; i ++ )
	{
		EnableWindow( GetDlgItem( Wnd, i ), State );
	}
}
