
//	Control Panel for Microsoft Xbox 360 Controller

//	X^eBbN
#define	IDC_STATIC								-1

//	ACR
#define	IDI_ICON								100

//	_CAO
#define	IDD_CONTROLLER							1000
#define	IDC_SETTING_LIST						1001
#define	IDC_SETTING_SAVE						1002
#define	IDC_SETTING_DELETE						1003
#define	IDC_X_AXIS								1004
#define	IDC_Y_AXIS								1005
#define	IDC_Z_AXIS								1006
#define	IDC_X_ROTATION							1007
#define	IDC_Y_ROTATION							1008
#define	IDC_Z_ROTATION							1009
#define	IDC_HAT_SWITCH1							1010
#define	IDC_HAT_SWITCH2							1011
#define	IDC_HAT_SWITCH3							1012
#define	IDC_HAT_SWITCH4							1013
#define	IDC_SLIDER1								1014
#define	IDC_SLIDER2								1015
#define	IDC_BUTTON								1016
#define	IDC_FORCE_FEEDBACK_TEST					1017

#define	IDD_STICK								1100
#define	IDC_LEFT_STICK_USAGE					1101
#define	IDC_LEFT_STICK_REVERSE					1102
#define	IDC_RIGHT_STICK_USAGE					1103
#define	IDC_RIGHT_STICK_REVERSE					1104
#define	IDC_STICK_DEAD_ZONE						1105
#define	IDC_STICK_THRESHOLD						1106

#define	IDD_DIRECTIONAL_PAD						1200
#define	IDC_DIRECTIONAL_PAD_USAGE				1201
#define	IDC_DIRECTIONAL_PAD_REVERSE				1202
#define	IDC_STATIC_301							1203
#define	IDC_STATIC_302							1204
#define	IDC_DIRECTIONAL_PAD_UP_USAGE			1205
#define	IDC_DIRECTIONAL_PAD_UP_RAPID_FIRE		1206
#define	IDC_STATIC_303							1207
#define	IDC_STATIC_304							1208
#define	IDC_DIRECTIONAL_PAD_DOWN_USAGE			1209
#define	IDC_DIRECTIONAL_PAD_DOWN_RAPID_FIRE		1210
#define	IDC_STATIC_305							1211
#define	IDC_STATIC_306							1212
#define	IDC_DIRECTIONAL_PAD_LEFT_USAGE			1213
#define	IDC_DIRECTIONAL_PAD_LEFT_RAPID_FIRE		1214
#define	IDC_STATIC_307							1215
#define	IDC_STATIC_308							1216
#define	IDC_DIRECTIONAL_PAD_RIGHT_USAGE			1217
#define	IDC_DIRECTIONAL_PAD_RIGHT_RAPID_FIRE	1218

#define	IDD_TRIGGER								1300
#define	IDC_LEFT_TRIGGER_USAGE					1301
#define	IDC_LEFT_TRIGGER_RAPID_FIRE				1302
#define	IDC_RIGHT_TRIGGER_USAGE					1303
#define	IDC_RIGHT_TRIGGER_RAPID_FIRE			1304
#define	IDC_TRIGGER_DEAD_ZONE					1305
#define	IDC_TRIGGER_THRESHOLD					1306

#define	IDD_BUTTON								1400
#define	IDC_BUTTON_LIST							1401
#define	IDC_BUTTON_USAGE						1402
#define	IDC_BUTTON_RAPID_FIRE					1403
#define	IDC_STATIC_501							1404
#define	IDC_STATIC_502							1405
#define	IDC_BUTTON_RAPID_FIRE_SPEED				1406
#define	IDC_STATIC_503							1407
#define	IDC_RING_LIGHT							1408

#define	IDD_FORCE_FEEDBACK						1500
#define	IDC_FORCE_FEEDBACK						1501
#define	IDC_STATIC_601							1502
#define	IDC_STATIC_602							1503
#define	IDC_STATIC_603							1504
#define	IDC_STATIC_604							1505
#define	IDC_LEFT_ACTUATOR_LEVEL					1506
#define	IDC_STATIC_605							1507
#define	IDC_STATIC_606							1508
#define	IDC_STATIC_607							1509
#define	IDC_RIGHT_ACTUATOR_LEVEL				1510
#define	IDC_STATIC_608							1511
#define	IDC_STATIC_609							1512
#define	IDC_STATIC_610							1513
#define	IDC_STATIC_611							1514
#define	IDC_STATIC_612							1515
#define	IDC_ACTUATOR_DEAD_ZONE					1516
#define	IDC_STATIC_613							1517

#define	IDD_DETAIL								1600
#define	IDC_STICK_DEAD_ZONE_BOX					1601
#define	IDC_STICK_DEAD_ZONE_CIRCLE				1602
#define	IDC_SLIDER_LIST							1603
#define	IDC_SLIDE_SLIDER_VALUE					1604
#define	IDC_SLIDE_CENTER_VALUE					1605
#define	IDC_REVERSE_SLIDER_VALUE				1606
#define	IDC_LIMITATION_MODE						1607
#define	IDC_DEVICES_ARE_POLLED					1608
#define	IDC_REDUCE_OUTPUT_REPORT				1609

#define	IDD_SETTING_SAVE						1700
#define	IDC_SETTING_NAME						1701

//	
#define	IDS_SHEET_CAPTION						2000

#define	IDS_NOTHING								2100

#define	IDS_AXIS								2200
#define	IDS_ROTATION							2201
#define	IDS_Z_AXIS_ROTATION						2202
#define	IDS_Z_AXIS_SLIDER1						2203
#define	IDS_Z_AXIS_SLIDER2						2204
#define	IDS_Z_ROTATION_AXIS						2205
#define	IDS_Z_ROTATION_SLIDER1					2206
#define	IDS_Z_ROTATION_SLIDER2					2207
#define	IDS_SLIDER1_Z_AXIS						2208
#define	IDS_SLIDER1_Z_ROTATION					2209
#define	IDS_SLIDER1_SLIDER2						2210
#define	IDS_SLIDER2_Z_AXIS						2211
#define	IDS_SLIDER2_Z_ROTATION					2212
#define	IDS_SLIDER2_SLIDER1						2213
#define	IDS_HAT_SWITCH1							2214
#define	IDS_HAT_SWITCH2							2215
#define	IDS_HAT_SWITCH3							2216
#define	IDS_HAT_SWITCH4							2217
#define	IDS_BUTTON_OR_SLIDER					2218

#define	IDS_A_BUTTON							2300
#define	IDS_B_BUTTON							2301
#define	IDS_X_BUTTON							2302
#define	IDS_Y_BUTTON							2303
#define	IDS_LB_BUTTON							2304
#define	IDS_RB_BUTTON							2305
#define	IDS_START_BUTTON						2306
#define	IDS_BACK_BUTTON							2307
#define	IDS_LEFT_STICK_BUTTON					2308
#define	IDS_RIGHT_STICK_BUTTON					2309
#define	IDS_XBOX_GUIDE_BUTTON					2310

#define	IDS_Z_AXIS_PLUS							2400
#define	IDS_Z_AXIS_MINUS						2401
#define	IDS_Z_ROTATION_PLUS						2402
#define	IDS_Z_ROTATION_MINUS					2403
#define	IDS_SLIDER1_PLUS						2404
#define	IDS_SLIDER1_MINUS						2405
#define	IDS_SLIDER2_PLUS						2406
#define	IDS_SLIDER2_MINUS						2407
#define	IDS_BUTTON1								2408
#define	IDS_BUTTON2								2409
#define	IDS_BUTTON3								2410
#define	IDS_BUTTON4								2411
#define	IDS_BUTTON5								2412
#define	IDS_BUTTON6								2413
#define	IDS_BUTTON7								2414
#define	IDS_BUTTON8								2415
#define	IDS_BUTTON9								2416
#define	IDS_BUTTON10							2417
#define	IDS_BUTTON11							2418
#define	IDS_BUTTON12							2419
#define	IDS_BUTTON13							2420
#define	IDS_BUTTON14							2421
#define	IDS_BUTTON15							2422
#define	IDS_BUTTON16							2423
#define	IDS_BUTTON17							2424
#define	IDS_BUTTON18							2425
#define	IDS_BUTTON19							2426
#define	IDS_BUTTON20							2427
#define	IDS_BUTTON21							2428
#define	IDS_BUTTON22							2429
#define	IDS_BUTTON23							2430
#define	IDS_BUTTON24							2431
#define	IDS_BUTTON25							2432
#define	IDS_BUTTON26							2433
#define	IDS_BUTTON27							2434
#define	IDS_BUTTON28							2435
#define	IDS_BUTTON29							2436
#define	IDS_BUTTON30							2437
#define	IDS_BUTTON31							2438
#define	IDS_BUTTON32							2439

#define	IDS_Z_AXIS								2500
#define	IDS_Z_ROTATION							2501
#define	IDS_SLIDER1								2502
#define	IDS_SLIDER2								2503

#define	IDS_RING_LIGHT_0						2600
#define	IDS_RING_LIGHT_1						2601
#define	IDS_RING_LIGHT_2						2602
#define	IDS_RING_LIGHT_3						2603
#define	IDS_RING_LIGHT_4						2604
#define	IDS_RING_LIGHT_5						2605
#define	IDS_RING_LIGHT_6						2606
#define	IDS_RING_LIGHT_7						2607
#define	IDS_RING_LIGHT_8						2608
#define	IDS_RING_LIGHT_9						2609
#define	IDS_RING_LIGHT_10						2610
#define	IDS_RING_LIGHT_11						2611
#define	IDS_RING_LIGHT_12						2612
#define	IDS_RING_LIGHT_13						2613
#define	IDS_RING_LIGHT_14						2614
#define	IDS_RING_LIGHT_15						2615

#define	IDS_LIMITATION_MODE_0					2700
#define	IDS_LIMITATION_MODE_1					2701
#define	IDS_LIMITATION_MODE_2					2702
#define	IDS_LIMITATION_MODE_3					2703

#define	IDS_DEFAULT_SETTING						2800
#define	IDS_MODIFIED							2801

#define	IDS_SAVE_TITLE							2901
#define	IDS_SAVE_MESSAGE						2902
#define	IDS_WARNING_TITLE						2903
#define	IDS_WARNING_MESSAGE						2904
#define	IDS_REPLACE_TITLE						2905
#define	IDS_REPLACE_MESSAGE						2906
#define	IDS_DELETE_TITLE						2907
#define	IDS_DELETE_MESSAGE						2908
#define	IDS_RESTART_TITLE						2909
#define	IDS_RESTART_MESSAGE						2910
