
//	Force Feedback Driver for Microsoft Xbox 360 Controller

#include	"X360CFF.h"

//----------------------------------------------------------------------------------------------
//	DllMain
//----------------------------------------------------------------------------------------------
STDAPI_(BOOL) DllMain(
	 HINSTANCE	Instance
	,DWORD		Reason
	,LPVOID		Reserved )
{
	//	ϐ錾
	BOOL	Result	= TRUE;

	switch( Reason )
	{
		case DLL_PROCESS_ATTACH:
			ProcessAttach( Instance );
			break;

		case DLL_PROCESS_DETACH:
			ProcessDetach();
			break;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	ProcessAttach
//----------------------------------------------------------------------------------------------
STDAPI_(void) ProcessAttach( HINSTANCE Instance )
{
	//	DLL_THREAD_ATTACH  DLL_THREAD_DETACH 𖳌ɂ
	DisableThreadLibraryCalls( Instance );

	//	NeBJ ZNV
	InitializeCriticalSection( &CriticalSection );
}

//----------------------------------------------------------------------------------------------
//	ProcessDetach
//----------------------------------------------------------------------------------------------
STDAPI_(void) ProcessDetach()
{
	//	NeBJ ZNV폜
	DeleteCriticalSection( &CriticalSection );
}
