
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	PageProc3
//----------------------------------------------------------------------------------------------
INT_PTR CALLBACK PageProc3(
	 HWND	Wnd
	,UINT	Message
	,WPARAM	wParam
	,LPARAM	lParam )
{
	//	ϐ錾
	INT_PTR	Result	= FALSE;

	//	bZ[WɂďU蕪
	switch( Message )
	{
		case WM_INITDIALOG:
			Result	= WM_InitDialog3( Wnd );
			break;

		case WM_COMMAND:
			Result	= WM_Command3( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_INITDIALOG
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_InitDialog3( HWND Wnd )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	upbh̋@\v
	InitComboBox( Wnd, IDC_DIRECTIONAL_PAD_USAGE, CENTER_PLUS );

	//	upbh̋@\v
	InitComboBox( Wnd, IDC_DIRECTIONAL_PAD_UP_USAGE, STRAIGHT );

	//	upbh̋@\v
	InitComboBox( Wnd, IDC_DIRECTIONAL_PAD_DOWN_USAGE, STRAIGHT );

	//	upbh̋@\v
	InitComboBox( Wnd, IDC_DIRECTIONAL_PAD_LEFT_USAGE, STRAIGHT );

	//	upbhE̋@\v
	InitComboBox( Wnd, IDC_DIRECTIONAL_PAD_RIGHT_USAGE, STRAIGHT );

	//	IĂݒ_CAOɔf
	SetPageSetting3( Wnd, &CurrentSetting );

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_COMMAND
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Command3(
	 HWND	Wnd
	,WORD	NotifyMessage
	,WORD	ControlID
	,HWND	Control )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_DIRECTIONAL_PAD_USAGE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	uʂɊ蓖āv̗LE؂ւ
					if( SendMessage( Control, CB_GETCURSEL, 0, 0 ) != WAY_POS_CENTER_PLUS )
					{
						EnableControl(
							 Wnd
							,IDC_STATIC_301
							,IDC_DIRECTIONAL_PAD_RIGHT_RAPID_FIRE
							,FALSE );
					} else {
						EnableControl(
							 Wnd
							,IDC_STATIC_301
							,IDC_DIRECTIONAL_PAD_RIGHT_RAPID_FIRE
							,TRUE );

						//	`FbN {bNX̗LE؂ւ
						SelectComboBox(
							 GetDlgItem( Wnd, IDC_DIRECTIONAL_PAD_UP_USAGE )
							,Wnd
							,IDC_DIRECTIONAL_PAD_UP_RAPID_FIRE
							,STRAIGHT );
						SelectComboBox(
							 GetDlgItem( Wnd, IDC_DIRECTIONAL_PAD_DOWN_USAGE )
							,Wnd
							,IDC_DIRECTIONAL_PAD_DOWN_RAPID_FIRE
							,STRAIGHT );
						SelectComboBox(
							 GetDlgItem( Wnd, IDC_DIRECTIONAL_PAD_LEFT_USAGE )
							,Wnd
							,IDC_DIRECTIONAL_PAD_LEFT_RAPID_FIRE
							,STRAIGHT );
						SelectComboBox(
							 GetDlgItem( Wnd, IDC_DIRECTIONAL_PAD_RIGHT_USAGE )
							,Wnd
							,IDC_DIRECTIONAL_PAD_RIGHT_RAPID_FIRE
							,STRAIGHT );
					}

					//	`FbN {bNX̗LE؂ւ
					SelectComboBox(
						 Control
						,Wnd
						,ControlID + 1
						,CENTER_PLUS );

					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

		case IDC_DIRECTIONAL_PAD_UP_USAGE:
		case IDC_DIRECTIONAL_PAD_DOWN_USAGE:
		case IDC_DIRECTIONAL_PAD_LEFT_USAGE:
		case IDC_DIRECTIONAL_PAD_RIGHT_USAGE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	`FbN {bNX̗LE؂ւ
					SelectComboBox( Control, Wnd, ControlID + 1, STRAIGHT );

					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

		case IDC_DIRECTIONAL_PAD_REVERSE:
		case IDC_DIRECTIONAL_PAD_UP_RAPID_FIRE:
		case IDC_DIRECTIONAL_PAD_DOWN_RAPID_FIRE:
		case IDC_DIRECTIONAL_PAD_LEFT_RAPID_FIRE:
		case IDC_DIRECTIONAL_PAD_RIGHT_RAPID_FIRE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	SetPageSetting3
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetPageSetting3(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;

	//	upbh̋@\v
	SetComboBox(
		 Wnd
		,IDC_DIRECTIONAL_PAD_USAGE
		,Setting->DirectionalPadUsage
		,IDC_DIRECTIONAL_PAD_REVERSE
		,CENTER_PLUS );
	SetCheckBox( Wnd, IDC_DIRECTIONAL_PAD_REVERSE, Setting->DirectionalPadReverse );
	if( Setting->DirectionalPadUsage == WAY_POS_CENTER_PLUS )
	{
		EnableControl(
			 Wnd
			,IDC_STATIC_301
			,IDC_DIRECTIONAL_PAD_RIGHT_RAPID_FIRE
			,TRUE );
	}

	//	upbhʂ̋@\v
	for( Index = 0; Index < 4; Index ++ )
	{
		SetComboBox(
			 Wnd
			,IDC_DIRECTIONAL_PAD_UP_USAGE + ( Index * 4 )
			,Setting->DirectionalPadWayUsage[Index]
			,IDC_DIRECTIONAL_PAD_UP_RAPID_FIRE + ( Index * 4 )
			,STRAIGHT );
		SetCheckBox(
			 Wnd
			,IDC_DIRECTIONAL_PAD_UP_RAPID_FIRE + ( Index * 4 )
			,Setting->DirectionalPadWayRapidFire[Index] );
	}
	if( Setting->DirectionalPadUsage != WAY_POS_CENTER_PLUS )
	{
		EnableControl(
			 Wnd
			,IDC_STATIC_301
			,IDC_DIRECTIONAL_PAD_RIGHT_RAPID_FIRE
			,FALSE );
	}
}

//----------------------------------------------------------------------------------------------
//	GetPageSetting3
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetPageSetting3(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;

	//	upbh̋@\v
	Setting->DirectionalPadUsage
		= GetComboBox( Wnd, IDC_DIRECTIONAL_PAD_USAGE );
	Setting->DirectionalPadReverse
		= GetCheckBox( Wnd, IDC_DIRECTIONAL_PAD_REVERSE );

	//	upbhʂ̋@\v
	for( Index = 0; Index < 4; Index ++ )
	{
		Setting->DirectionalPadWayUsage[Index]
			= GetComboBox( Wnd, IDC_DIRECTIONAL_PAD_UP_USAGE + ( Index * 4 ) );
		Setting->DirectionalPadWayRapidFire[Index]
			= GetCheckBox( Wnd, IDC_DIRECTIONAL_PAD_UP_RAPID_FIRE + ( Index * 4 ) );
	}
}
