
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	SetRegistry
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetRegistry(
	 VOID *		Value
	,ULONG		ValueType
	,ULONG		ValueSize
	,_TCHAR *	ValueName )
{
	//	ϐ錾
	HKEY	Key;
	DWORD	Disposition;
	LONG	Result;

	//	WXgJ
	Result	= RegCreateKeyEx(
				 HKEY_LOCAL_MACHINE
				,REGISTRY_SUB_KEY
				,0
				,NULL
				,REG_OPTION_NON_VOLATILE
				,KEY_ALL_ACCESS
				,NULL
				,&Key
				,&Disposition  );
	if( Result == ERROR_SUCCESS )
	{
		//	WXgɏ
		RegSetValueEx( Key, ValueName, 0, ValueType, (LPBYTE)Value, ValueSize );
		//	WXg
		RegCloseKey( Key );
	}
}

//----------------------------------------------------------------------------------------------
//	GetRegistry
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetRegistry(
	 VOID *		Value
	,ULONG		ValueType
	,ULONG		ValueSize
	,_TCHAR *	ValueName )
{
	//	ϐ錾
	HKEY	Key;
	DWORD	Disposition;
	LONG	Result;
	DWORD	Type;
	DWORD	Size;

	//	WXgJ
	Result	= RegCreateKeyEx(
				 HKEY_LOCAL_MACHINE
				,REGISTRY_SUB_KEY
				,0
				,NULL
				,REG_OPTION_NON_VOLATILE
				,KEY_ALL_ACCESS
				,NULL
				,&Key
				,&Disposition  );
	if( Result == ERROR_SUCCESS )
	{
		//	WXgǂݍ
		Type	= ValueType;
		Size	= ValueSize;
		RegQueryValueEx( Key, ValueName, NULL, &Type, (LPBYTE)Value, &Size );
		//	WXg
		RegCloseKey( Key );
	}
}

//----------------------------------------------------------------------------------------------
//	DelRegistry
//----------------------------------------------------------------------------------------------
STDAPI_(void) DelRegistry( _TCHAR * ValueName )
{
	//	ϐ錾
	HKEY	Key;
	DWORD	Disposition;
	LONG	Result;

	//	WXgJ
	Result	= RegCreateKeyEx(
				 HKEY_LOCAL_MACHINE
				,REGISTRY_SUB_KEY
				,0
				,NULL
				,REG_OPTION_NON_VOLATILE
				,KEY_ALL_ACCESS
				,NULL
				,&Key
				,&Disposition  );
	if( Result == ERROR_SUCCESS )
	{
		//	WXg폜
		RegDeleteValue( Key, ValueName );
		//	WXg
		RegCloseKey( Key );
	}
}
